#include "portScanner.h"

//Accumulators
unsigned int i = 0;
unsigned int j = 0;

FILE *file = NULL;

struct timeval now;
struct timespec offset;

int PORTS[MAX_PORTS];
int NUM_PORTS = MAX_PORTS;
char *IP_ADDRS[MAX_IP_ADDRS];
int NUM_IP_ADDRS = MAX_IP_ADDRS;
char *IP_ADDR = NULL;
char *IP_PREFIX = NULL;
int PREFIX_LENGTH = 0;
char *FILE_NAME = NULL;
int TRANSPORT = 0; //0 for TCP, 1 for UDP, 2 for both (default)
int NUM_THREADS = 0;
int IS_FLAG_SET = 0;
int IS_IDLE_SET =0;
int IS_DECOY_SET;
int MAX_DECOY_SCANS = 0;
char *decoy_ip_addrs[DECOY_SCANS];
int MAX_IDLE_SCANS = 0;
char *idle_ip_addrs[IDLE_SCANS];

u_char mode_flags = 0x00;
/* 0x00000001 = SYN
   0x00000010 = ACK
   0x00000100 = FIN
   0x00001000 = NULL
   0x00010000 = XMAS
   0x00100000 = DECOY
   0x01000000 = IDLE */

int main(int argc, char **argv) {

	build_ports();

	if(argc < 2) {
		fprintf(stderr, "Error: No IP Address or Options specified.\n");
	}
	if(argc == 2) {
		if(strcmp(*(argv+1), "--help") == 0) {
			displayHelp();
			exit(0);
		} else {
			IP_ADDR = argv[1];
		}
	}
	if(argc > 2) {
		for(i = 1; i < argc; i++) {
			if(strcmp(*(argv+i), "--help") == 0) 
				displayHelp();
			if(strcmp(*(argv+i), "--ports") == 0) {
				j = 0;
				NUM_PORTS = 0;
				do {
					PORTS[j++] = atoi(*(argv+(++i)));
					NUM_PORTS++;
					if((i+1) >= argc) break;
				} while(strspn(*(argv+(i+1)), "-") < 1);
			}
			if(strcmp(*(argv+i), "--ip") == 0) 
				IP_ADDR = *(argv+(++i));
			if(strcmp(*(argv+i), "--prefix") == 0) {
				IP_PREFIX = *(argv+(++i));
				char *prefix_ptr;
				prefix_ptr = strpbrk(IP_PREFIX, "/");
				PREFIX_LENGTH = atoi(prefix_ptr+1);
				*prefix_ptr = '\0';
			}
			if(strcmp(*(argv+i), "--file") == 0) 
				FILE_NAME = *(argv+(++i));
			if(strcmp(*(argv+i), "--transport") == 0) 
				TRANSPORT = (strcmp(*(argv+(++i)), "TCP") == 0) ? 0 : 1;
			if(strcmp(*(argv+i), "--flags") == 0) {
				do {
					IS_FLAG_SET = 1;
					if(strcmp(*(argv+(++i)), "SYN") == 0)
						mode_flags = SET_BIT(mode_flags, 0);
					else if(strcmp(*(argv+i), "ACK") == 0)
						mode_flags = SET_BIT(mode_flags, 1);
					else if(strcmp(*(argv+i), "FIN") == 0)
						mode_flags = SET_BIT(mode_flags, 2);
					else if(strcmp(*(argv+i), "NULL") == 0)
						mode_flags = SET_BIT(mode_flags, 3);
					else if(strcmp(*(argv+i), "XMAS") == 0)
						mode_flags = SET_BIT(mode_flags, 4);
					else if(strcmp(*(argv+i), "ALL") == 0) {
						mode_flags = SET_BIT(mode_flags, 0);
						mode_flags = SET_BIT(mode_flags, 1);
						mode_flags = SET_BIT(mode_flags, 2);
						mode_flags = SET_BIT(mode_flags, 3);
						mode_flags = SET_BIT(mode_flags, 4);
					}
					if((i+1) >= argc) break;
				} while(strspn(*(argv+(i+1)), "-") < 1);
			}
			if(strcmp(*(argv+i), "--mode") == 0) {
				IS_FLAG_SET =1;;
				if(strcmp(*(argv+(++i)), "DECOY") == 0) {
					do {
						IS_DECOY_SET =1;
						decoy_ip_addrs[MAX_DECOY_SCANS++] = *(argv+(++i));
						if((i+1) >= argc) break;
					} while(strspn(*(argv+(i+1)), "-") < 1);
				}
				else if(strcmp(*(argv+i), "IDLE") == 0) {
					do {
						IS_IDLE_SET =1;
						idle_ip_addrs[MAX_IDLE_SCANS++] = *(argv+(++i));
						if((i+1) >= argc) break;
					} while(strspn(*(argv+(i+1)), "-") < 1);
				}
			}
		}
	}
	/*
	for(i = 0; i < MAX_DECOY_SCANS; i++) {
		printf("decoy[%d]: %s\n",i, decoy_ip_addrs[i]);
	}

	for(i = 0; i < MAX_IDLE_SCANS; i++) {
		printf("idle[%d]: %s\n",i, idle_ip_addrs[i]);
	}
	*/
	//printf("mode_flags: %x\n", mode_flags);
	if(IS_FLAG_SET) {
		printf("Scan\t%15s:Port\tState\t\tFirewall Inferences\n", "Host");
	} else {
		fprintf(stdout, "%15s:%s  %s\t\t%s\t%s\t\t%s\n", "Host", "Port", "State", "Prtcl", "Service", "Version");
	}

	conquer();

	return 0;
}
