#include "portScanner.h"

unsigned int i;
unsigned int j;

u_char mode_flags;

void *ip_scan(void *thread_args) {
	int acc;
	t_arg_array *t_args = (t_arg_array *)thread_args;
	t_arg_array *new_args = (t_arg_array *)malloc(sizeof(t_arg_array));

	int *t_port = t_args->port;

	new_args->ip = (char *)t_args->ip;
	//fprintf(stdout, "\nHOST: %s\n", new_args->ip);

	for(acc = 0; acc < NUM_PORTS; acc++) {    
		//push args
		new_args->port = (int *)((t_args->port)+acc);

		//fprintf(stdout, "Port used: %d\n", *(new_args->port));
		if(IS_FLAG_SET) {
			port_flag_scan((void *)new_args);
		} else {
			port_connect((void *)new_args);
		}
	}
	free(new_args);
}


unsigned int gen_random_ip(void) {
	FILE *urand;
	unsigned int seed;

	urand = fopen("/dev/urandom", "r");
	fread(&seed, sizeof(int), 1, urand);
	srand(seed);
	fclose(urand);

	return seed;
}

void decoy_scan(void *thread_args) {
  int scan_type;
  t_arg_array *target_machine = (t_arg_array *)thread_args;
  char *recv_buff;
  
  for(i = 0; i < MAX_DECOY_SCANS; i++) {
    scan_type = gen_random_number(1,5);
    generic_port_flag_scan((void *)target_machine, &recv_buff, 1, decoy_ip_addrs[i],scan_type);
  }
  
  //send actual scan
  //int i = 0;
  int flag_resp [5];
  for(i = 0; i < 5; i++) {
    flag_resp[i] =-1;
    if((mode_flags) & (1 << i)) {
      generic_port_flag_scan((void *)target_machine, &recv_buff, 0, NULL, i+1);
      if (recv_buff != NULL){
	flag_resp[i] = parse_buffer(recv_buff, (1 << i));
	 generic_port_flag_scan((void *)target_machine, &recv_buff, 0, NULL, i+1);
      }else{
	parse_timeout((void*) thread_args,(1<<i));
	flag_resp[i] = -1;
      }
    }   
  }
  //infer summary here
  if(mode_flags != 1 && mode_flags != 2 && mode_flags != 4 && mode_flags != 8 && mode_flags != 16)
    port_flag_scan_summary(flag_resp);
  
}

void idle_scan(void *thread_args) {
  struct ip *ip_hdr;
  struct tcphdr *tcp_hdr;
  char *recv_buff;
  u_short ip_id, ip_id2;
	t_arg_array *target_machine = (t_arg_array *)thread_args;
	int bait_port = 65535;

	for(i = 0; i < MAX_IDLE_SCANS; i++) {
		t_arg_array *bait_machine = calloc(1, sizeof(t_arg_array));
		bait_machine->ip = idle_ip_addrs[i];
		bait_machine->port = &bait_port;

		//send SYN scan to bait machine on closed port
		mode_flags = 0x01;
		generic_port_flag_scan((void *)bait_machine, &recv_buff, 0, NULL,1);

		//parse received buffer for IP ident field
		if(recv_buff !=NULL){ 
			ip_hdr = (struct ip *)recv_buff;
			ip_id = ntohs(ip_hdr->ip_id);
		}else{
			printf("bait machine timeout...\n");
			continue;
		} 
		//send spoofed SYN to target
		generic_port_flag_scan((void *)target_machine, &recv_buff, 1, idle_ip_addrs[i],1);

		sleep(1);

		//send SYN scan to bait machine
		generic_port_flag_scan((void *)bait_machine, &recv_buff, 0, NULL,1);
		if(recv_buff !=NULL){ 
			//parse received buffer for IP ident field
			ip_hdr = (struct ip *)recv_buff;
			ip_id2 = ntohs(ip_hdr->ip_id);

			free(bait_machine);

			ip_id = ip_id2 - ip_id;

			printf("IP ID difference: %d\n", ip_id);

			if(ip_id == 1) {
				printf("IDLE\t%15s:%d\tClosed\n",target_machine->ip,*target_machine->port);
				return;
			} else if(ip_id == 2) {
				printf("IDLE\t%15s:%d\tOpen\n",target_machine->ip,*target_machine->port);
				return;
			} else if((i+1) != MAX_IDLE_SCANS) {
				printf("Bait machine %s in use, trying next...\n", idle_ip_addrs[i]);
			}
		}else{
			printf("Bait machine scan timed out, using another machines..\n");
		}
	} //end for loop

	printf("All bait machines used, try different addresses\n");
	return;
}

void build_ports(void) {
	for(i = 0; i < MAX_PORTS; i++) {
		PORTS[i] = i+1;
	}
	return;
}

void conquer(void) {
	t_arg_array *t_args;

	if(FILE_NAME || IP_PREFIX) {
		int prefix_iter = 1 << (32 - PREFIX_LENGTH);

		if(FILE_NAME) {
			if((file = fopen(FILE_NAME, "r")) == NULL) {
				fprintf(stderr, "Error: Cannot open file %s", FILE_NAME);
				exit(1);
			}

			char *ip[MAX_IP_ADDRS];
			for(i = 0; i < MAX_IP_ADDRS; i++)
				ip[i] = (char *)malloc(sizeof(char));

			i = -1;
			NUM_IP_ADDRS = 0;

			//read IP addresses from file
			while(!feof(file)) {
				fscanf(file, "%s\n", ip[++i]);
				*(IP_ADDRS+i) = *(ip+i);
				NUM_IP_ADDRS++;
			}
		}
		if(IP_PREFIX) {
			unsigned int b_prefix = endian_switch(inet_addr(IP_PREFIX));
			struct in_addr tmp_addr;

			char *tmp[prefix_iter];
			for(i = 0; i < prefix_iter; i++) {
				tmp[i] = (char *)malloc(sizeof(char));
			}

			NUM_IP_ADDRS = prefix_iter;

			for(i = 0; i < prefix_iter; i++) {
				tmp_addr.s_addr = endian_switch(b_prefix+i);
				memcpy(tmp[i], inet_ntoa(tmp_addr), strlen(inet_ntoa(tmp_addr)));
				IP_ADDRS[i] = tmp[i];
			}
		}

		int d;
		for(d = 0; d < NUM_IP_ADDRS; d++) {
			t_args = (t_arg_array *)malloc(sizeof(t_arg_array));

			t_args->ip = IP_ADDRS[d];
			t_args->port = PORTS;

			ip_scan((void *)t_args);

			free(t_args);
		}

		if(FILE_NAME) {
			fclose(file);
		}
	} else {
		int r;
		for(r = 0; r < NUM_PORTS; r++) {
			t_args = (t_arg_array *)malloc(sizeof(t_arg_array));

			t_args->ip = IP_ADDR;
			t_args->port = (int *)&PORTS[r];

			if(IS_FLAG_SET) {
				port_flag_scan((void *)t_args);
			}
			else {
				port_connect((void*)t_args);
			}


			//free(t_args);
		}
	}
}

