#include "portScanner.h"
#include<stdio.h>
#include<string.h>
#include <sys/ioctl.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <net/if.h>

void diep(char *s) {
	printf("\n\nDying\n");
	perror(s);
}
void displayHelp(void) {
	printf("\t*** Port Scanner ***\n");
	printf("    Ali Khalfan and Brennon York\n\n");
	printf("NAME\n");
	printf("\tportScanner - Multi-threaded TCP/UDP Port Scanner\n\n");
	printf("SYNOPSIS\n");
	printf("\tportScanner [ip_addr]\n");
	printf("\tportScanner [--help]\n\n");
	printf("\tportScanner [[--ports [<port_num> ...]] [[--ip <ip_addr>] |\n"); 
	printf("\t             [--prefix <ip_prefix>] | [--file <file_name>]]\n");
	printf("\t             [--transport <layer>] [--speedup <num_threads>]]\n");
	printf("OPTIONS\n");
	printf("\t--help\n");
	printf("\t\tDisplays all invocation options and explains their goals.\n");
	printf("\t--ports\t\n");
	printf("\t\tAllows user to specify individual ports instead of the\n");
	printf("\t\tdefault range of 1 to 1024.\n");
	printf("\t--ip\n");
	printf("\t\tExplicitly state the IP Address to scan.\n");
	printf("\t--prefix\n");
	printf("\t\tGiven an IP Address in prefix notation it will scan over the\n");
	printf("\t\tports specified for all addresses in the range after the\n");
	printf("\t\tprefix.  Prefix notation is given as 123.456.789.0/24 where\n");
	printf("\t\t123.456.789 is the prefix and 24 is the prefix length.\n");
	printf("\t--file\n");
	printf("\t\tGive a filename of IP Addresses to scan over.  This file\n");
	printf("\t\tshould present each individual address on a separate line.\n");
	printf("\t--transport\n");
	printf("\t\tState which transport layer to scan, either TCP or UDP.  By\n");
	printf("\t\tdefault this will scan both.\n");
	printf("\t--speedup [NOT AVAILABLE IN THIS VERSION]\n");
	printf("\t\tLets the user determine the number of threads to enable.\n");
	printf("\t\tIf the number of threads given is greater than the number\n");
	printf("\t\tof ports to scan and there is no file present then it will\n");
	printf("\t\tdefault to the number of ports.  If the number of threads\n");
	printf("\t\tis greater than the number of IP Addresses presented in a\n");
	printf("\t\tgiven file then the number of threads is set to the number\n");
	printf("\t\tof IP Addresses read in.\n");
	printf("\t--flags\n");
	printf("\t\tAllows the user to input any of the specified scans they\n");\
		printf("\t\twish to run.  Currently supports scans for SYN, ACK, FIN,\n");
	printf("\t\tNULL, and XMAS.  These do not need to be ran separately and\n");
	printf("\t\tif multiple scans are given the best results per port are\n");
	printf("\t\tdisplayed.\n");
	printf("\t--mode\n");
	printf("\t\tThis will enable the user to specify which mode he would\n");
	printf("\t\tlike the scans to run in.  Currently there are two modes\n");
	printf("\t\tavailable (DECOY / IDLE) and only one can be given.\n");
	return;
}

unsigned int endian_switch(unsigned int big) {
	unsigned char byte;
	unsigned long little = 0x00000000;
	little = big << 24;
	byte = big >> 8;
	little ^= byte << 16;
	byte = big >> 16;
	little ^= byte << 8;
	little ^= big >> 24;
	return little;
}
unsigned int gen_random_number(unsigned int min, unsigned int max) {
	FILE *urand;
	unsigned int seed;

	urand = fopen("/dev/urandom", "r");
	fread(&seed, sizeof(unsigned int), 1, urand);
	srand(seed);
	fclose(urand);
	unsigned int range = max - min +1;
	
	return (seed %range)+ min;
	return 0;	
}
unsigned short in_cksum_tcp(char * datagram){

	struct ip *ip_hdr = (struct ip *) datagram;
	struct tcphdr  *tcp_hdr = (struct tcphdr *) (datagram + sizeof(struct ip));


	u_short length = (20);

	u_char is_even = !(length%2);

	u_char *buffer;
	if(is_even) { //even...
		buffer = calloc((length + 12), 1);
	} else { //odd...
		buffer = calloc((length + 13), 1);
	}

	u_short *ptr, *tcp_ptr;

	tcp_ptr = (u_short *)tcp_hdr;
	u_char *tcp_ptr2 = (u_char *)tcp_hdr;
	ptr = (u_short *)buffer;
	u_int *lptr = (u_int *)buffer;

	int i =0;
	for(i =0;i< (length); i++){

	}

	*(lptr++) = (ip_hdr->ip_src.s_addr);



	*(lptr++) = (ip_hdr->ip_dst.s_addr);

	ptr += 4;
	*(ptr++) = htons(((u_char)((0x06))));
	*(ptr++) = htons((u_short)20);
	memcpy(ptr, tcp_ptr, 20);


	register u_long sum = 0;
	int count = (is_even)? ((length + 12) / 2):
		((length + 13) / 2);
	int j =0;

	u_short * buffers = (u_short *)buffer;

	return (cksum(buffers,count));

}

//code obtained from the Computer Networks 4th Edition book
u_short cksum(u_short *buf, int count) {
	register u_long sum = 0;
	while(count--) {
		//			printf("%x||",htons((u_short)*buf));
		sum += htons(((u_short)*buf++));
		if(sum & 0xFFFF0000) {
			sum &= 0xFFFF;
			sum++;
		}
	}
	return ~(sum & 0xFFFF);
}

char* get_this_ipaddr(int s ,char * dst_ip_addr){

	struct ifreq *ifr, *ifend;
	struct ifreq ifreq;
	struct ifconf ifc;
	struct ifreq ifs[64];


	ifc.ifc_len = sizeof(ifs);
	ifc.ifc_req = ifs;
	if (ioctl(s, SIOCGIFCONF, &ifc) < 0)
	{
		diep("ioctli:");
		return "0.0.0.0"; //this is mainly to avoid seg faults
	}


	ifend = ifs + (ifc.ifc_len / sizeof(struct ifreq));
	for (ifr = ifc.ifc_req; ifr < ifend; ifr++)
	{
		if (ifr->ifr_addr.sa_family == AF_INET)
		{
			strncpy(ifreq.ifr_name, ifr->ifr_name,sizeof(ifreq.ifr_name));
			if (ioctl (s, SIOCGIFHWADDR, &ifreq) < 0)
			{
				diep(ifreq.ifr_name);
				return "0.0.0.0" ; //mainly to avoid seg faults
			}
			if ((strcmp(dst_ip_addr, "127.0.0.1") == 0) || strcmp(dst_ip_addr,"localhost") == 0){ //if the destination is a localhost than it's almost certainly a loopback therefore obtain the source address from the loopback
				if (strcmp(ifr->ifr_name,"lo") == 0){
					return (char*)inet_ntoa( ( (struct sockaddr_in *)  &ifr->ifr_addr)->sin_addr);

				}
			}else{ //if any other ip address than obtain the address from the interface that is not a loopback
			if (strcmp(ifr->ifr_name, "lo")!= 0){
				return (char*)inet_ntoa( ( (struct sockaddr_in *)  &ifr->ifr_addr)->sin_addr); //return the string val of sockaddress_in
			}
		}
		}

	}
}

int parse_buffer(char* buffer, int flag) {
	struct ip *ip_hdr;
	struct tcphdr *tcp_hdr;

	if((int)buffer>0){
		ip_hdr = (struct ip *) buffer;
		tcp_hdr = (struct tcphdr *)(buffer + sizeof(struct ip));
	}
	switch(flag) {
		case 1: //SYN
			if(buffer) {

				if(tcp_hdr->syn && tcp_hdr->ack) {
					printf(" SYN\t%15s:%d\tOpen\n",inet_ntoa(ip_hdr->ip_src),ntohs(tcp_hdr->source));
					return 1;
				} else if(tcp_hdr->rst) {
					printf(" SYN\t%15s:%d\tClosed\n",inet_ntoa(ip_hdr->ip_src),ntohs(tcp_hdr->source));
					return 0;
				} else {
					printf(" SYN\t%15s:%d\tUnknown (No RST)\n",inet_ntoa(ip_hdr->ip_src),ntohs(tcp_hdr->source));
				}
			} else {
				//printf(" SYN\t%15s:%d\tFiltered\tFiltering SYN scans\n",inet_ntoa(ip_hdr->ip_src),ntohs(tcp_hdr->source));
			}
			break;
		case 2: //ACK
			if(buffer) {
				if(tcp_hdr->rst) {
					printf(" ACK\t%15s:%d\tUnfiltered\tStateless\n",inet_ntoa(ip_hdr->ip_src),ntohs(tcp_hdr->source));
					return 1;
				} else {
					printf("Unknown (No RST)\n");
				}
			}
			break;
		case 4: //FIN
			if(buffer) {
				if(tcp_hdr->rst) {
					printf(" FIN\t%15s:%d\tClosed\t\tUnfiltered\n",inet_ntoa(ip_hdr->ip_src),ntohs(tcp_hdr->source));
					return 0;
				} else {
					//printf("Unknown (No RST)\n");
				}
			} else {
				// printf(" FIN\t%15s:%d\tOpen\t\tFiltered\n",inet_ntoa(ip_hdr->ip_src),ntohs(tcp_hdr->source));
			}
			break;
		case 8: //NULL
			if(buffer) {
				if(tcp_hdr->rst) {
					printf("NULL\t%15s:%d\tClosed\n",inet_ntoa(ip_hdr->ip_src),ntohs(tcp_hdr->source));
					return 0;
				} else {
					printf("Unknown\n");
				}
			} else {
				// printf("NULL\t%15s:%d\tOpen\n",inet_ntoa(ip_hdr->ip_src),ntohs(tcp_hdr->source));
			}
			break;
		case 16: //XMAS
			if(buffer) {
				if(tcp_hdr->rst) {
					printf("XMAS\t%15s:%d\tClosed\n",inet_ntoa(ip_hdr->ip_src),ntohs(tcp_hdr->source));
					return 0;
				} else {
					printf("Unknown\n");
				}
			} else {
				// printf("XMAS\t%15s:%d\tOpen\n",inet_ntoa(ip_hdr->ip_src),ntohs(tcp_hdr->source));
			}
			break;
	}  
}

void parse_timeout(void * thread_args, int flag){
	t_arg_array *t_args = (t_arg_array *)thread_args;


	char *t_ip_addr = t_args->ip;
	int *t_port = t_args->port;




	switch(flag){
		case 1:

			printf(" SYN\t%15s:%d\tFiltered\tFiltering SYN scans\n",t_ip_addr,*t_port);
			break;
		case 2:
			printf(" ACK\t%15s:%d\tFiltered\tStateful\n",t_ip_addr,*t_port);
			break;
		case 4:
			printf(" FIN\t%15s:%d\tOpen|Filtered\t\tFiltered\n",t_ip_addr,*t_port);
			break;
		case 8:
			printf(" NULL\t%15s:%d\tOpen|Filtered\t\tFiltered\n",t_ip_addr,*t_port);
			break;
		case 16:

			printf(" XMAS\t%15s:%d\tOpen|Filtered\t\tFiltered\n",t_ip_addr,*t_port);
			break;

	}


}

void port_flag_scan_summary(int  flag_resp[]){

	//search for either 1s or 0s if found good , 
	//else simply indicate that the machine is filtered
	int resPos = 0;
	
		printf("Port Summary:\n");
	for (resPos =0; resPos < 5; resPos++){
		if ((flag_resp[resPos] == 1 || flag_resp[resPos] == 0) && resPos != 1){
			if (flag_resp[resPos] ==1)
				printf("port is  open\n\n");
			else if (flag_resp[resPos] ==0)
				printf("port is closed\n\n");

		//	return;
			goto firewall;
		}

	}
	if(flag_resp[1] == -1){
		printf("Port is most likely filtered\n\n");
	}
	else if (flag_resp[1] ==1){

		printf("port is most likely open\n\n");

	}

	firewall: printf("Firewall Inference:\n");
	if (mode_flags == 3){// just SYN and ACK
		if (flag_resp[0] == 1 && flag_resp[1] == -1){
			printf("stateful filtering is in effect\n\n");
		}else if ((flag_resp[0] == 1 || flag_resp[0] == 0) && flag_resp[1] == 1){
			printf("no filtering in effecti\n\n");
		}else if (flag_resp[0] == -1 && flag_resp[1] == -1){
			printf("filtering  port (unkown filtering type)\n\n");
		}

	}
	if (mode_flags == 7 || mode_flags == 11 || mode_flags == 19 || mode_flags == 27 || mode_flags == 31){ //SYN, ACK and any of thee SCANS
		if (flag_resp[0]==1){
			if(flag_resp[1] ==1 ){
				printf("no filtering in effect\n\n");
			}
		if (flag_resp[1] == -1){
			printf("stateful filtering in effect\n\n");
		}

		

		}else if (flag_resp[0] = -1){
			if (flag_resp[1] == -1){
			printf("port filtering in effect (unkown type)\n\n");
			}
		
		}
	}
	else if (mode_flags == 2 || mode_flags ==6 || mode_flags ==14 || mode_flags ==30){ //ACK and any of the three last scans
		if (flag_resp[1] == 1){
			printf("no filtering seems to be in effect\n\n");
		}
		else if (flag_resp[1] == -1){
			printf("filter in effect, firewall type cannot be determined\n\n");
		}

	}else if (mode_flags == 5 || mode_flags == 13 || mode_flags == 29){ //SYN and any of the three last scans

		if(flag_resp[0] == -1 &&(flag_resp[2] != -1 || flag_resp[3] != -1 || flag_resp[4] != -1) ) {
			printf("firewall filters SYN scan, though no further inference can be made\n\n");
		
		}else if ((flag_resp[0] == 1) && (flag_resp[2] == 0 || flag_resp[3] == 0 ||  flag_resp[4] == 0)){
			printf("Device unfiltered,  may belong to windows  \n\n");
		}else if ((flag_resp[0] == 1) && (flag_resp[2] != -1 || flag_resp[3] != -1 || flag_resp[4] != -1)){
			printf("Statefule Firewall in effect\n\n");

		}else if ((flag_resp[0] == 1) && (flag_resp[2] != 1 && flag_resp[3] != 1 && flag_resp[4] != 1)){
			printf("Unkown firewall information \n\n");
		}

		
	}
	



} 
